// $Header: /home/ra/ride/rap/lambda/Geom3d/RCS/Point_test.cxx,v 1.1 1996/02/23 02:02:08 mackay Exp mackay $
// This program tests some of the Point class functions defined in Geom3d.h,

#include "Geom3d.hxx"
//==============================
int main(int argc, char **argv)
{
  std::cout << "Test Point constructors\n";
  Point p1;
  Point p2(1.05, 10.0, 2.0);
  Point p3(1.0, 0.0, 0.0);
  std::cout << "\tp1 = " << p1 << '\n';
  std::cout << "\tp2 = " << p2 << '\n';
  std::cout << "\tp3 = " << p3 << '\n';

  std::cout << "Test Point component access functions:\n";
  p1.x = 1.0;
  p1.y = 1.5;
  p1.z = 2.0;
  std::cout << "\t\"p1.x=1.0, p1.y=1.5, p1.z=1.0\"\n";
  std::cout << "\tp1 = " << p1 << '\n';

  std::cout << "\tp1.x="<<p1.x;
  std::cout << "\tp1.y="<<p1.y;
  std::cout << "\tp1.z="<<p1.z << '\n';

  std::cout << "p1+p2=" << p1+p2 << '\n';
  std::cout << "p1-p2=" << p1-p2 << '\n';
  std::cout << "p1*3=" << p1*3 << '\n';
  std::cout << "p1/3=" << p1/3 << '\n';

  p1 /=3; std::cout << "p1/=3:" << p1 << '\n';
  p1 *=3; std::cout << "p1*=3:" << p1 << '\n';

  p1 +=p2; std::cout << "p1+=p2:" << p1 << '\n';
  p1 -=p2; std::cout << "p1-=p2:" << p1 << '\n';

  Point p4 = -p1;
  std::cout << "\tp4=-p1: p4 = " << p4 << '\n';

  std::cout << "p1 * p3 = " << p1*p3 << '\n';
  std::cout << "p1 x p3 = " << cross(p1,p3) << '\n';
  std::cout << "distance(p1,p2) = " << distance(p1,p2) << '\n';

  std::cout << "p1*3:" << p1*3 << '\n';
  std::cout << "3*p1:" << 3*p1 << '\n';
  std::cout << "p1/3:" << p1/3 << '\n';

  std::cout << "p1==p1:" << (p1==p1);
  std::cout << "\tp1!=p1:" << (p1!=p1);
  std::cout << "\tp1==p2:" << (p1==p2);
  std::cout << "\tp1!=p2:" << (p1!=p2) << '\n';


  std::cout << "\tp1 = " << p1 << '\n';
  std::cout << "rotate_x(p1,acos(0.0)) = " << rotate_x(p1,acos(0.0)) << '\n';
  std::cout << "rotate_y(p1,acos(0.0)) = " << rotate_y(p1,acos(0.0)) << '\n';
  std::cout << "rotate_z(p1,acos(0.0)) = " << rotate_z(p1,acos(0.0)) << '\n';

  p2 = Point(1.0,1.0,1.0);
  std::cout << "p2 = " << p2 << '\n';
  p3 = normalize(p2);
  std::cout << "normalize(p2)" << normalize(p2) << '\n';
  std::cout << "magnitude(p2)" << magnitude(p2) << '\n';




  return 0;
}
