// $Header: /home/ra/ride/rap/lambda/Geom3d/RCS/test.cxx,v 1.1 1996/02/23 02:02:08 mackay Exp mackay $
// This program tests some of the class functions defined in Geom3d.h,
// i.e., the "Point", "Line", and "Plane" classes.

#include "Geom3d.hxx"
//using namespace std;


int main()
{
  std::cout << "Test Point constructors\n";
  Point p1;
  Point p2(0.0, 0.0, 1.0);
  Point p3(1.0, 0.0, 0.0);
  std::cout << "\tp1 = " << p1 << "\n";
  std::cout << "\tp2 = " << p2 << "\n";
  std::cout << "\tp3 = " << p3 << "\n";

  std::cout << "Test Point component access functions:\n";
  p3.x = 1.0;
  p3.y = 1.5;
  p3.z = 1.0;
  std::cout << "\t\"p3.x=1.0, p3.y=1.5, p3.z=1.0\"\n";
  std::cout << "\tp3 = " << p3 << "\n";

  std::cout << "\tp3.x="<<p3.x;
  std::cout << "\tp3.y="<<p3.y;
  std::cout << "\tp3.z="<<p3.z<<"\n";

  std::cout << "p1 = p3: ";
  p1 = p3;
  std::cout << "\tp1 = " << p1 << "\n";

  std::cout << "p4 = -p1: ";
  Point p4 = -p1;
  std::cout << "\tp4 = " << p4 << "\n";

  std::cout << "p1 . p3 = " << p1*p3 << "\n";
  std::cout << "p1 x p3 = " << cross(p1,p3) << "\n";
  std::cout << "distance(p1,p2) = " << distance(p1,p2) << "\n";



  std::cout << "\tp1 = " << p1 << "\n";
  p4 = rotate_x(p1,acos(0.0));
  std::cout << "\tp4 = " << p4 << "\n";

  std::cout << "    2*p4 = " << 2.0*p4 << "\n";

  std::cout << "p1==p1, p1==p2: " << (p1==p1) << " , " << (p1==p2) << "\n";
  std::cout << "\n";
  
  std::cout << "\tPoint(1,2,3) = "<<Point(1.0, 2.0, 3.0)<<"\n";

/* Now let's try some of the Line functions */
  std::cout << "\nNow try some of the Line functions\n";

  Line l1(p1,p2);
  Line l2;
  std::cout << "l1:"<<l1<<"\n";
  std::cout << "l2:"<<l2<<"\n";
  double dist;
  std::cout << "intersection: " << intersect(l1,l2,&dist) << "\n";
  std::cout << "\t\t dist = " << dist << "\n";

  l1 = Line(Point(0,0,0),1,1,1);
  l2 = Line(Point(1,0,0),Point(0,1,0));
  std::cout << "l1:"<<l1<<"\n";
  std::cout << "l2:"<<l2<<"\n";
  std::cout << "intersection: " << intersect(l1,l2,&dist) << "\n";
  std::cout << "\t\t dist = " << dist << "\n";
  
  l2 = l1+p1;
  std::cout << "l1:"<<l1<<"\n";
  std::cout << "l2:"<<l2<<"\n";
  std::cout << "intersection: " << intersect(l1,l2,&dist) << "\n";
  std::cout << "\t\t dist = " << dist << "\n";
  
/* Plane */

  Plane m1(0.0,1.0,1.0,1.0);
  std::cout << "p1 =" << p1 << "\n";
  std::cout << "Plane m1: " << m1 << "\n";
  std::cout << "dist(p1,m1) = " << distance(p1,m1) << "\n";

  return 0;
}
