#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <malloc.h>
 
#include <string>
#include <iostream>
#include "mat6/mat6.hxx"


//==============
mat6 exp6(mat6 X, int n)
{ // Calculates the exponential of a 6x6 matrix to nth order
  mat6 A, T;
  int i;
  double f = 1.0;

  for(i=1;i<n+1;i++)
    {
      T = T*X;
      f = f/(double)i;
      A = A+f*T;
    }
  return A;
}
//-------------
#ifdef MAIN
int main(int argc, char** argv)
{
  mat6 A, B;
  int i, j, k;
  double randnorm = 1.0/(double)RAND_MAX;

  k = 10;
  if(argc==2) k = atoi(argv[1]);
  std::cout << "k=" << k << "\n";
  B.zero();
  for(i=0;i<6;i++)
    {
      for(j=i+1;j<6;j++)
	{
	  B.m[i][j] = (double)rand()*randnorm;
	}
    }
  A.zero();
  A.m[1][0] = 0.3;
  A.m[2][3] = 0.1;
  A.m[3][2] = -A.m[2][3];
  
  std::cout << "A:" << A  << "\n";
  std::cout << "exp(A):" << exp6(A, k)  << "\n";

  std::cout << "B:" << B  << "\n";
  std::cout << "exp(B):" << exp6(B, k)  << "\n";


  return 0;
}
#endif
