#include <iostream>
#include "su2/su2spinor.hxx"

int main(int argc, char** argv)
{
  su2mat A, B, C;
  double pi = acos(-1.0);

  std::cout << "pi = " << pi << "\n";
  std::cout << "A =  "<< A << "\n";
  //  A = unit();
  A.unit();
  std::cout << "A =  "<< A << "\n";
  std::cout << "B =  "<< B << "\n";
  B.unit();
  std::cout << "B =  "<< B << "\n";

  std::cout << "B+B = " << B+B << "\n";

  B = Rx(pi);
  std::cout << "B =  "<< B << "\n";
  
  A = Rz(pi)*B;
  std::cout << "A =  "<< A << "\n";

  C = inv(A);
  std::cout << "C =  "<< C << "\n";

  B = A*C;
  std::cout << "A*C = "<< B << "\n";

  Point v(0, 0, 0.8), u;
  std::cout << "v = " << v << "\n";
  su2spinor psi(v), w;
  std::cout << "psi =\n["<<psi<<" ]\n";
  u = vector(psi);
  std::cout << "u = "<<u<<"\n";

  std::cout << "psi =\n["<<psi<<"]\n";
  std::cout << "Rx(pi/2) =\n"<<Rx(pi/2)<<"\n";
  w = Rx(pi/2)*psi;
  std::cout << "w =\n [ "<<w<<" ]\n";

  std::cout << "w*.w =\n["<<w*w<<" ]\n";
  std::cout << "dagger(w)*Rx(pi/2)=\n"<<dagger(w)*Rx(pi/2)<<"\n";

  return 0;
}

