#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <fstream>
#include <string>

std::string GIline;
char giline[128];
std::string GIfile;
std::ifstream GIf;
FILE* fgdmp;

std::string	flatname;	//name of flat.lat file
std::string	snakefile;	//defines parameters for synthetic snakes
std::string	bumpfile;	//defines parameters for bumps
std::string	solfile;	//	B values of experiment solenoids
std::string	dBoBfile;	//field errors for magnets
std::string	offsetfile;	//defines list of x and y offsets to be rescaled
double	scaleoffset;	//scale factor for offsets in <offsetfile>
std::string	gidump;	//	name of output file for dump of parameters, ...
std::string	orbitfile;	//file to write out trajectory at each element
std::string	matfile;	//	output file of elements	for debuggery
int	lmatfile;	//=0 not to dump matrices; otherwise dump them
std::string	smfile;	//	file to write out spin matrices
int	lsm;	//	=0 not to dump spin matrices; otherwise dump them
std::string	spinorfile;	//output file for spinor tracking
int	lspinor;	//	=0 not to dump spinors; otherwise dump them
std::string	corrfile;	//file to write out final steering corrector settings
int	lcorrdmp;	//=0 not to dump final corrector settings to file
double	c;	//	[m] speed of light in vacuum
std::string	particle;	//type of beam particle, e.g. "p" for protons
double	G;	//	anomalous magnetic moment factor
double	mc2;	//	[GeV] mass of beam particle
double	Z;	//	charge state of beam particle
double	amu;	//	total number of nucleons of beam particle
double	design_length;	//[m] design circumference (length) of ring (beamline)
double	U0;	//	[GeV] total energy of synchronous particle
double	kqd;	//	arc quad strength for qd buss to adjust tune
double	kqf;	//	arc quad strength for qf buss to adjust tune
std::string	rfSWN;	//	SiteWideName of the cavity
int	harmnum;	//	harmonic number
double	Vrf;	//	[V] rf voltage amplitude across gap
double	phirf;	//	synchronous phase (=0 for no acceleration)
int	clorb;	//	=0 use init coords; find closed orb otherwise.
int	nlin;	//	=0 for linear optics only; otherwise use nonlin optics
double	x_init;	//	[m] initial orbit coordinate
double	xp_init;	//	[radian] initial orbit coordinate
double	y_init;	//	[m] initial orbit coordinate
double	yp_init;	//	[radian] initial orbit coordinate
double	z_init;	//	[m] initial orbit coordinate
double	delta_init;	//initial orbit coordinate  (deltap/p0)
int	helicity;	//	=1 to align to initial velocity vector
double	Sxin;	//	initial Sx component  note these get renormalized
double	Syin;	//	initial Sy component  note these get renormalized
double	Szin;	//	initial Sz component  note these get renormalized
int	nbsteps;	//	>=1: divide dipoles into nbsteps slices; <1 resets to 1
int	nqsteps;	//	>=1: divide quads into nbsteps slices; <1 resets to 1
double	zerotol;	//	tolerance for zeros
int	lstrobave;	//=0 to skip multiturn & stroboscopic averaging
int	npart;	//	number of particles to track
int	nturns;	//	number of turns to average
std::string	nvifile;	//	filename for initial phase-space and spin values
std::string	nvffile;	//	filename for final phase-space and spin values
std::string	nvtbtfile;	//filename for turn-by-turn phasespace and spin points

#include "nl_blspin_ginp.inc"
#include "nl_blspin_gdmp.inc"
